<template>
  <div class="coinbase-commerce-iframe-container" v-loading="loading">
    <iframe
      @load="onLoaded"
      class="coinbase-commerce-iframe"
      :src="src"
      scrolling="no"
      frameBorder="no"
      v-if="src"
    />
    <CloseButton @click.native="close" />
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  watch,
  onMounted,
  onUnmounted
} from '@nuxtjs/composition-api'
import CloseButton from './ui/CloseButton.vue'
import useGenerateUUID from '@/hooks/generate-uuid'
import type { MessageData } from '@/types/coinbase'

const origin = 'https://commerce.coinbase.com'

type SrcParams = {
  origin: string
  buttonId: string
  cacheDisabled: boolean
}

export default defineComponent<{
  chargeId: string | null
}>({
  name: 'CoinbaseModal',
  props: ['chargeId'],
  components: { CloseButton },
  setup(props, { root, emit }) {
    const loading = ref(true)
    const src = ref<string | null>(null)
    const uuid = useGenerateUUID()

    const onLoaded = () => {
      loading.value = false
    }

    const isValidMessage = (msg: {
      origin: string
      data: MessageData
    }): boolean => {
      return msg.origin === origin && msg.data.buttonId === uuid
    }

    const handleMessage = (msg: { origin: string; data: MessageData }) => {
      if (!isValidMessage(msg)) {
        return
      }

      switch (msg.data.event) {
        case 'charge_confirmed':
          root.$emit('success', msg.data)
          break

        case 'charge_failed':
          root.$emit('failed', msg.data)
          break

        case 'payment_detected':
          root.$emit('payment-detected', msg.data)
          break

        case 'error_not_found':
          root.$emit('error', msg.data)
          break

        case 'checkout_modal_closed':
          close()
          break

        default:
          // Do nothing
          break
      }
    }

    onMounted(() => {
      window.addEventListener('message', handleMessage)
    })

    onUnmounted(() => {
      window.removeEventListener('message', handleMessage)
    })

    function encodeURIParams(params: SrcParams) {
      const encoded = []
      const quote = window.encodeURIComponent
      for (const key in params) {
        if (params[key as keyof SrcParams]) {
          encoded.push(quote(key) + '=' + quote(params[key as keyof SrcParams]))
        }
      }
      return encoded.join('&')
    }

    watch(props, () => {
      if (props.chargeId) {
        const hostName = `${window.location.protocol}//${
          window.location.hostname
        }${window.location.port ? ':' + window.location.port : ''}`

        const params: SrcParams = {
          origin: hostName,
          buttonId: uuid,
          cacheDisabled: false
        }

        src.value = `${origin}/embed/charges/${window.encodeURI(
          props.chargeId
        )}?${encodeURIParams(params)}`
      }
    })

    function close() {
      emit('close')
      root.$nextTick(() => (loading.value = true))
    }

    return { loading, src, onLoaded, close }
  }
})
</script>

<style lang="scss" scoped>
.coinbase-commerce-iframe-container {
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  width: 100%;
  height: 100%;
  position: fixed;
  z-index: 99998;

  background-color: rgba(#252d45, 0.7);
}

.coinbase-commerce-iframe {
  position: fixed;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  z-index: 99999;
  height: 100%;
  width: 100%;
  border: none;
}

::v-deep .el-loading-mask {
  background-color: transparent;
}

.close-button {
  position: fixed;
  top: 23px;
  right: 23px;
  z-index: 100000;
  background-color: #2c344d;
}
</style>
